# NEMA.py
# version .2: obj: cree la methode step() de Nema

import string

def C2L(car):
	return string.index(string.ascii_uppercase,car)

def L2C(lettre):
	return  string.ascii_uppercase[lettre]

class Rotor:
	def __init__(self,nomDuRotor):
		fic = open("rotors/"+nomDuRotor+".rot","r")
		PI = fic.readline()
		#print "===> ", nomDuRotor, PI
		self.nom = nomDuRotor
		self.decal = range(26)
		self.decal_inv = range(26)
		self.index = 0
		tampon = range(26)
		for i in range(26):
			indice = C2L(PI[i])
			self.decal[i] = ( indice - i + 26 ) % 26
		for i in range(26):
			tampon[ C2L( PI[i] ) ] = i
		for i in range(26):
			self.decal_inv[i] = ( tampon[i] - i + 26 ) % 26

	def getNom(self):
		return self.nom

	def setGrund(self,x):
		self.index = x
	def getGrund(self):
		return L2C(self.index)
	def avance(self):
		self.index = (self.index + 1) % 26
	def recule(self):
		self.index = (self.index - 1 + 26) % 26
	def chiffre(self,x):
		return (x + self.decal[ (x + self.index + 26)%26 ]) % 26
	def dechiffre(self,x):
		return (x + self.decal_inv[ (x+ self.index + 26)%26 ]) % 26

class Drive:
	def __init__(self,nomDuDrive):
		fic = open("rotors/"+nomDuDrive+".drv","r")
		PI = fic.readline()
		#print "===> ", nomDuDrive, PI, 
		self.nom = nomDuDrive
		self.index = 0
		self.Pins = range(26)
		for i in range(26):
			v = int(PI[i])
			self.Pins[i] = v
		#print self.Pins

	def getNom(self):
		return self.nom
	def getGrund(self):
		return L2C(self.index)
	def setGrund(self,x):
		self.index = x
	def getVal(self):
		return self.Pins[ self.index ]
	def avance(self):
		self.index = (self.index + 1) % 26
	def recule(self):
		self.index = (self.index - 1 + 26) % 26		


class Nema:
	def __init__(self, keyIntern, keyExtern, keyRed, debug):
		self.debug = debug
		lesRotDrv = keyIntern.split(":")
		RedDrv = keyRed.split(":")
		if self.debug: print lesRotDrv, keyRed, keyExtern
		self.compteur = 0
		self.rotor_etw  = Rotor("ETW")
		self.drive_d0 = Drive( RedDrv[1] )
		self.drive_d1 = Drive( RedDrv[0] )
		self.rotor_r2 = Rotor( lesRotDrv[7] )
		self.drive_d3 = Drive( lesRotDrv[6] )
		self.rotor_r4 = Rotor( lesRotDrv[5] )
		self.drive_d5 = Drive( lesRotDrv[4] )
		self.rotor_r6 = Rotor( lesRotDrv[3] )
		self.drive_d7 = Drive( lesRotDrv[2] )
		self.rotor_r8 = Rotor( lesRotDrv[1] )
		self.drive_d9 = Drive( lesRotDrv[0] )
		self.rotor_reflec = Rotor("UKW")
		self.setGrund(keyExtern)		

	def getGrund(self):
		grund = ""
		grund = grund + self.rotor_reflec.getGrund()
		grund = grund + self.drive_d9.getGrund()
		grund = grund + self.rotor_r8.getGrund()
		grund = grund + self.drive_d7.getGrund()
		grund = grund + self.rotor_r6.getGrund()
		grund = grund + self.drive_d5.getGrund()
		grund = grund + self.rotor_r4.getGrund()
		grund = grund + self.drive_d3.getGrund()
		grund = grund + self.rotor_r2.getGrund()
		grund = grund + self.drive_d1.getGrund()
		#grund = grund + self.drive_d0.getGrund()
		return grund

	def setGrund(self,grund):
		self.drive_d0.setGrund(C2L(grund[9]))
		self.drive_d1.setGrund(C2L(grund[9]))
		self.rotor_r2.setGrund(C2L(grund[8]))
		self.drive_d3.setGrund(C2L(grund[7]))
		self.rotor_r4.setGrund(C2L(grund[6]))
		self.drive_d5.setGrund(C2L(grund[5]))
		self.rotor_r6.setGrund(C2L(grund[4]))
		self.drive_d7.setGrund(C2L(grund[3]))
		self.rotor_r8.setGrund(C2L(grund[2]))
		self.drive_d9.setGrund(C2L(grund[1]))
		self.rotor_reflec.setGrund(C2L(grund[0]))

	def step(self):
		if ( self.debug and self.compteur == 0 ):
			print 9,7,5,3,"L","R", self.getGrund(), 
			print "                           ", self.compteur
		Pins = range(10)
		Pins[9] = self.drive_d9.getVal()
		Pins[7] = self.drive_d7.getVal()
		Pins[5] = self.drive_d5.getVal()
		Pins[3] = self.drive_d3.getVal()
		Pins[1] = self.drive_d1.getVal()
		Pins[0] = self.drive_d0.getVal()
		if self.debug: print Pins[9],Pins[7],Pins[5],Pins[3],Pins[1],Pins[0],
		self.drive_d9.recule()
		self.drive_d5.recule()
		self.drive_d1.recule()
		self.drive_d0.recule()
		if ( Pins[9] ): self.rotor_reflec.recule()
		if ( Pins[5] ): self.rotor_r6.recule()
		if ( Pins[1] ): self.rotor_r2.recule()
		if ( Pins[0] ): self.drive_d3.recule()
		if ( Pins[0] ): self.drive_d7.recule()
		if ( Pins[0] and Pins[7] ): self.rotor_r8.recule()
		if ( Pins[0] and Pins[3] ): self.rotor_r4.recule()
		if self.debug: print self.getGrund(),

	def encode(self,car):
		lettre = C2L(car)
		self.compteur = self.compteur + 1
		if self.debug: print L2C(lettre),
		lettre = self.rotor_etw.chiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r2.chiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r4.chiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r6.chiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r8.chiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_reflec.chiffre(lettre)
		if self.debug: print "<", L2C(lettre), ">", 
		lettre = self.rotor_r8.dechiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r6.dechiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r4.dechiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_r2.dechiffre(lettre)
		if self.debug: print L2C(lettre),
		lettre = self.rotor_etw.dechiffre(lettre)
		if self.debug: print L2C(lettre), self.compteur
		return L2C(lettre)

	def decode(self,car):
		return encode( self, car)


if __name__ == "__main__":
	e = Nema("21:B:16:A:20:D:19:C","CCCCCCCCCC", "23:02", 1 )	

        msg = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
        crypto = ""
	cpt = 0
        for i in range(len(msg)):
		e.step()
 
                car = e.encode( msg[i] )
                crypto = crypto + car
		cpt = cpt + 1
        print crypto
